#include <avr/io.h>

#if defined(__AVR_ATmega32__)
#define CI_LATCH PB2
#elif defined(__AVR_AT90S8515__)
#define CI_LATCH PB2
#elif defined(__AVR_ATmega8__)
#define CI_LATCH PB1
#elif defined(__AVR_ATmega48__)
#define CI_LATCH PB1
#endif

#include "controller_input.h"

void controller_input_init(void)
{
    //Assuming SPI setup by LED driver.
    DDRB|=1<<CI_LATCH;//Set latch as output.
    PORTB|=1<<CI_LATCH;//Data latch active low (keep high).
}

unsigned char controller_input_get(void)
{
    PORTB&=~(1<<CI_LATCH);//Latch switches.

    SPDR=0xFF;//Output one byte to activate SPI input.
    while(!(SPSR&0x80));//Wait for transfer complete.

    PORTB|=1<<CI_LATCH;//Unlatch shift register.

    return ~SPDR;//Clear second SPIF flag and return input value.
}
